from __future__ import annotations

from typing import TYPE_CHECKING

import config
import bozodown
from path import Path


class Page:
    
    def __init__(self, path: Path):
        self._path: Path = path
        self._html: Path = Path(self._path.get_absolute_path()[:-len(config.PAGE_EXT)] + ".html")
        with open(path.get_absolute_path(), "r") as f:
            self._raw_content: str = f.read()

    def _get_content(self):
        content = bozodown.render(self._raw_content)
        return content
    
    def _to_html(self) -> str:
        html: str = self._get_content()
        return html

    def create(self) -> Path:
        with open(self._html.get_absolute_path(), "w") as f:
            f.write(self._to_html())